
#include "StdAfx.h"
#include "AddChatWnd.h"
#include "NeMessengerDlg.h"
#include "main_frame.hpp"
#include "SendNoteMananger.h"
#include "DuiDefine.h"
#include "DialPadDlg.h"
#include "MemoSendDlg.h"
#include "SMSSendWnd.h"

const int kInviteWindowWidth = 340;
const int kInviteWindowHeight = 400;
const int kOrganizationItemFileHeight = 24;
const int kOrganizationItemUserHeight = 29;

const TCHAR* const kLogoContainerControlName = _T("logo_container");
const TCHAR* const kDescriptionControlName = _T("description");
const TCHAR* const kOperatorPannelControlName = _T("operation");

#define CHECK_ON	_T("btn_chat_talk_checkboc_on.png")
#define CHECK_OFF	_T("btn_chat_talk_checkboc_off.png")

static bool OnLogoButtonEvent(void* event) {
	TEventUI *pEvent = (TEventUI*)event;
	static CString strOldImage = _T("");
	if( ((TEventUI*)event)->Type == UIEVENT_BUTTONDOWN ) {
		CControlUI* pButton = ((TEventUI*)event)->pSender;
		if( pButton != NULL ) 
		{
			CListContainerElementUI* pListElement = (CListContainerElementUI*)(pButton->GetTag());
			if( pListElement != NULL ) 
			{
				CListUI *pThis = (CListUI *)pListElement->GetOwner();
				CPaintManagerUI* pm = pThis->GetManager();
			//	CButtonUI* logo_hot_button = static_cast<CButtonUI*>(pm->FindSubControlByName(pListElement, _T("logo_hot")));
				CButtonUI* logo_button = static_cast<CButtonUI*>(pm->FindSubControlByName(pListElement, kLogoButtonControlName));
				if (/*logo_hot_button!=NULL &&*/ logo_button!=NULL)
				{
				/*	CRect rcpadding(0,0,0,0);
					pButton->SetPadding(rcpadding);
					logo_hot_button->SetVisible(true);*/
					CRect rcItem = pButton->GetPos();
					Node* pNode = (Node*)pListElement->GetTag();
					if (pNode != NULL)
					{
                        CRect rcRootWnd(0, 0, 0, 0);
						GetWindowRect(pm->GetPaintWindow(),&rcRootWnd);
						RECT rcAround = {};
						rcAround.right = rcItem.right + rcRootWnd.left;
						rcAround.left = rcItem.left + rcRootWnd.left ;
						rcAround.top = rcItem.top +  rcRootWnd.top;
						rcAround.bottom = rcItem.bottom + rcRootWnd.top ;
						if (GET_CONFIG()->EnableFunction(_T("UI_03")))
						{
							GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(pNode->data().value.GetData(), rcAround, pm->GetPaintWindow());
						}
					}

					CString strImage =GetAppDUIImgDir() +_T("\\img_main_mouse_move.png");				
					logo_button->SetBkImage(strImage);
				}
				pListElement->DoEvent(*pEvent);
			}
		}
		
	}
	else  if( ((TEventUI*)event)->Type == UIEVENT_MOUSEENTER )	
	{
		CControlUI* pButton = ((TEventUI*)event)->pSender;
		if( pButton != NULL ) 
		{
			CListContainerElementUI* pListElement = (CListContainerElementUI*)(pButton->GetTag());
			if( pListElement != NULL ) 
			{
				CListUI *pThis = (CListUI *)pListElement->GetOwner();
				CPaintManagerUI* pm = pThis->GetManager();
				CButtonUI* logo_button = static_cast<CButtonUI*>(pm->FindSubControlByName(pListElement, _T("logo")));
				if (logo_button!=NULL )
				{
					//Node* pNode = (Node*)pListElement->GetTag();
					CString strImage =GetAppDUIImgDir() + _T("\\img_main_mouse_move.png");
					strOldImage = logo_button->GetBkImage();
					logo_button->SetBkImage(strImage);
				}
				pListElement->DoEvent(*pEvent);
			}
		}
	}
	else if(((TEventUI*)event)->Type== UIEVENT_MOUSELEAVE )
	{
		CControlUI* pButton =((TEventUI*)event)->pSender;
		if( pButton != NULL ) 
		{
			CListContainerElementUI* pListElement = (CListContainerElementUI*)(pButton->GetTag());
			if( pListElement != NULL ) 
			{
				CListUI *pThis = (CListUI *)pListElement->GetOwner();
				CPaintManagerUI* pm = pThis->GetManager();
				CButtonUI* log_hot_button = static_cast<CButtonUI*>(pm->FindSubControlByName(pListElement, _T("logo")));
				if (log_hot_button!=NULL){
					log_hot_button->SetBkImage(strOldImage);
				}
				pListElement->DoEvent(*pEvent);
			}
		}
	}
	return true;
}

DUI_BEGIN_MESSAGE_MAP(CAddChatWnd, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_SETFOCUS, _OnNotifySetFocus)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_KILLFOCUS, _OnNotifyKillFocus)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_HEADERCLICK, _OnNotifyHeaderClick)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_HEADERDRAG, _OnNotifyHeaderDrag)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_RETURN, _OnNotifyReturn)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_ESCAPE, _OnNotifyEscape)
    
    DUI_ON_CLICK_CTRNAME(kCloseButtonControlName, _OnCtrlCloseBtnClick)
    DUI_ON_CLICK_CTRNAME(kSearchLabel, _OnCtrlSearchLabelClick)
    DUI_ON_CLICK_CTRNAME(kSearchBtn, _OnCtrlSearchBtnClick)
    DUI_ON_CLICK_CTRNAME(kSearchCancel, _OnCtrlSearchCancelClick)
    DUI_ON_CLICK_CTRNAME(kAddChatItemCheck, _OnCtrlAddChatItemCheckClick)
    DUI_ON_CLICK_CTRNAME(kInviteOK, _OnCtrlInviteOKClick)
    DUI_ON_CLICK_CTRNAME(kInviteCancel, _OnCtrlInviteCancelClick)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CAddChatWnd)
    ON_CUSTOM_MSG(WM_KEYDOWN, _OnMsgKeyDown)
DUI_END_CUSTOM_MSG_MAP()

CAddChatWnd::CAddChatWnd(CWnd* pParent, int nType)
{
	InitClassData();
	m_pCWndParent = pParent;
	m_nParentType = nType;
    m_pDUIParent = NULL;
    m_pParentSmsSendWnd = NULL;
}

CAddChatWnd::CAddChatWnd( WindowImplBase* pParent, int nType )
{
	InitClassData();
    m_pCWndParent = NULL;
	m_pDUIParent = pParent;
	m_nParentType = nType;
    m_pParentSmsSendWnd = NULL;
}

CAddChatWnd::~CAddChatWnd()
{
	if (root_node_ != NULL)
	{
		delete root_node_;
		root_node_ = NULL;
	}
}


void CAddChatWnd::InitClassData()
{
	m_pParentChatDlg = NULL;
	m_pImageDownloadThread = NULL;
	m_hInternetSession = NULL;
	m_hHttpConnection = NULL;
	m_hHttpFile = NULL;
	m_bAbort = FALSE;
	m_bSafeToClose = FALSE;
	m_rcClient.SetRectEmpty();
	text_padding_ = CDuiRect(0, 0, 0, 0);
	root_node_ = new Node;
	root_node_->data().level_ = -1;
	root_node_->data().child_visible_ = true;
	root_node_->data().has_child_ = true;
	root_node_->data().list_elment_ = NULL;
}


void CAddChatWnd::InitWindow()
{
	CLabelUI* titleName = static_cast<CLabelUI*>(m_PaintManager.FindControl(kAddChatTitleName));
	if (titleName != NULL)
	{
		titleName->SetText(LoadStringFromResource(IDS_ADD_CHAT_USER));
	}

	CListHeaderItemUI* pListItemName = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatName));
	if (pListItemName != NULL)
	{
		pListItemName->SetText(LoadStringFromResource(IDS_STRING142));
	}
	CListHeaderItemUI* pListItemPos = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatPosition));
	if (pListItemPos != NULL)
	{
		pListItemPos->SetText(LoadStringFromResource(IDS_STRING268));
	}
	CListHeaderItemUI* pListItemOrg = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatOrganization));
	if (pListItemOrg != NULL)
	{
		pListItemOrg->SetText(LoadStringFromResource(IDS_STRING143));
	}
	CButtonUI* pBtnOK = static_cast<CButtonUI*>(m_PaintManager.FindControl(kInviteOK));
	if (pBtnOK != NULL)
	{
		pBtnOK->SetText(LoadStringFromResource(IDS_STRING_INVITE_ADD));
		pBtnOK->SetEnabled(false);
	}
	CButtonUI* pBtnCancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kInviteCancel));
	if (pBtnCancel != NULL)
	{
		pBtnCancel->SetText(LoadStringFromResource(IDS_STRING569));
	}
	CButtonUI* pBtnCLose = static_cast<CButtonUI*>(m_PaintManager.FindControl(kCloseButtonControlName));
	if (pBtnCLose != NULL)
	{
		pBtnCLose->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_7));
	}
	CButtonUI* pBtnSearch = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchBtn));
	if (pBtnSearch != NULL)
	{
		pBtnSearch->SetToolTip(LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_17));
	}
	
	InitList();
	
}

void CAddChatWnd::SetWindowPosition(CRect rcParent)
{
    CRect rcMonitor(0, 0, 0, 0);
	MONITORINFO oMonitor = {};
	oMonitor.cbSize = sizeof(oMonitor);
	if(m_nParentType == ADD_USER_FROM_SMS)
	{
		::GetMonitorInfo(::MonitorFromWindow(m_pDUIParent->GetHWND(), MONITOR_DEFAULTTONEAREST), &oMonitor);
	}
	else
	{
		::GetMonitorInfo(::MonitorFromWindow(m_pCWndParent->GetSafeHwnd(), MONITOR_DEFAULTTONEAREST), &oMonitor);
	}
	
	rcMonitor = oMonitor.rcWork;
	int nLeft = rcParent.left - kInviteWindowWidth - 5;
	int nRight = rcParent.right + kInviteWindowWidth + 5;
	if (nLeft<rcMonitor.left && nRight>rcMonitor.right)
	{
		CenterWindow();
		::ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
		return;
	}
	if(nLeft < rcMonitor.left)
	{
		nLeft = rcParent.right + 5;
	}
	::SetWindowPos(m_hWnd, NULL, nLeft, rcParent.top, kInviteWindowWidth, kInviteWindowHeight, SWP_FRAMECHANGED | SWP_SHOWWINDOW);
}

int __cdecl CAddChatWnd::ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2)
{
	if (!pvlocale || !elem1 || !elem2)
		return 0;

	IGTBuddyUser **pUser1 = (IGTBuddyUser**)elem1;
	IGTBuddyUser **pUser2 = (IGTBuddyUser**)elem2;
	CString Name1 = (*pUser1)->GetName();
	CString Name2 = (*pUser2)->GetName();

	int Sts1 = (int)(*pUser1)->GetStatus();
	int Sts2 = (int)(*pUser2)->GetStatus();

	return BuddyItemComareFunc(STRUCT_BUDDY_COMPARE(Name1,Sts1), STRUCT_BUDDY_COMPARE(Name2,Sts2));


}

int __cdecl CAddChatWnd::MemberDataItemComareFunc(void *pvlocale,const void *elem1, const void *elem2)
{
	if (!pvlocale || !elem1 || !elem2)
		return 0;

	ORG_MEMBER_DATA *pData1 = (ORG_MEMBER_DATA*)elem1;
	ORG_MEMBER_DATA *pData2 = (ORG_MEMBER_DATA*)elem2;
	WSTRING Name1 = pData1->neMemberData.strName;
	WSTRING Name2 = pData2->neMemberData.strName;

	return StrCmpCW(Name1.c_str(),Name2.c_str());
}

void CAddChatWnd::SetParentChatDlg(CChatDlg* pDlg)
{
	m_pParentChatDlg = pDlg;
}

void CAddChatWnd::SetParentSmsSendWnd(CSMSSendWnd* pSmsWnd)// The same reason as "SetParentChatDlg"
{
  m_pParentSmsSendWnd = pSmsWnd;
}


void CAddChatWnd::SetInChatRoom(CString strAllUserID)
{
	m_strInChatRoom = strAllUserID + _T(", ") + g_pMessengerActor->GetUserID();;
	SetListItemStatus();
}

void CAddChatWnd::SetListItemStatus()
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		int nCount = pList->GetCount();
		for (int i=0; i<nCount; ++i)
		{
			CControlUI* pItem = pList->GetItemAt(i);
			CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
			
			if (item_check != NULL)
			{
				CAddUserListData *pMembereData = (CAddUserListData*)item_check->GetTag();
				if (m_nParentType == ADD_USER_FROM_CHAT)
				{
					int pos = m_strInChatRoom.Find(pMembereData->GetUserID());
					if (pos != -1)
					{
						item_check->SetEnabled(false);
					}
				}
			}
		}
	}
}

void CAddChatWnd::InitList()
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		unsigned int index = 0;
		std::vector<const IGTBuddyUser*> vecBuddyUser;
		size_t nBuddyCount = g_pMessengerActor->GetBuddyCount();
		for (index = 0; index < nBuddyCount; index++)
        {
			const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(index);
            vecBuddyUser.push_back(pUser);
        }
		if (vecBuddyUser.size() > 1)
		{
			qsort_s(&(vecBuddyUser.at(0)), vecBuddyUser.size(), sizeof(IGTBuddyUser*), CAddChatWnd::ItemComareFunc, this);	
		}

		for (index = 0; index < vecBuddyUser.size(); index++)
		{
			const IGTBuddyUser* pUser = vecBuddyUser[index];

			CString strID = pUser->GetUserID();
			AddChatListItemInfo item;
			item.id = strID;
			item.folder = false;
			//item.empty = false;
			item.nick_name = pUser->GetName();
			const NE_MEMBER_DATA* pMembereData = g_pMessengerActor->GetEmployeeInfo(strID); 
			item.position = pMembereData->strJobPos.c_str();
			item.organization = pMembereData->strDept.c_str();

			CString strImage = _T("");
			GTUserStatusType eUserStatus = pUser->GetStatus();
			bool mobile = ( eUserStatus & ustMOBILE );
			if ((eUserStatus!=ustOFFLINE) || mobile || m_nParentType != ADD_USER_FROM_CHAT)
			{
                strImage = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(eUserStatus,mobile,!pMembereData->strWorkStatus.empty());;
			}
			else
			{
				continue;
			}
			item.logo = strImage;

			BOOL bFind = FALSE;
			for (size_t i=0; i<m_vecMemberData.size(); ++i)
			{
				if (m_vecMemberData[i]->GetUserID() == strID)
				{
					bFind = TRUE;
					break;
				}
			}
			if (!bFind)
			{
				AddNode(item, NULL, pMembereData, eUserStatus);
				GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->AddBuddyMember(*pMembereData, pUser->GetStatus(), pUser->GetIPTStatus());
			}
		}
		ResizeList();
	}
}

bool CAddChatWnd::RemoveNode(Node* node)
{
	if (!node || node == root_node_) return false;

	int nCount = node->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = node->child(i);
		RemoveNode(child);
	}
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		pList->Remove(node->data().list_elment_);
	}
	node->parent()->remove_child(node);
	delete node;

	return true;
}

void CAddChatWnd::RemoveAllMenberList()
{
	for (size_t i=0; i<m_vecMemberData.size(); ++i)
	{
		CAddUserListData* pData = m_vecMemberData[i];
		SAFE_DELETE(pData);  //lint !e438
	}
	m_vecMemberData.clear();
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		pList->RemoveAll();
		int nCount = root_node_->num_children();
		for (int i = nCount - 1; i >=0;  i--)
		{
			Node* child = root_node_->child(i);
			RemoveNode(child);
		}
		delete root_node_;
		root_node_ = new Node;
		root_node_->data().level_ = -1;
		root_node_->data().child_visible_ = true;
		root_node_->data().has_child_ = true;
		root_node_->data().list_elment_ = NULL;
	}
}

void CAddChatWnd::InitMemberList(const std::vector<ORG_MEMBER_DATA> &memberVector)
{
	RemoveAllMenberList();
	if(memberVector.size() > 1)
	  qsort_s((void*)&(memberVector.at(0)), memberVector.size(), sizeof(ORG_MEMBER_DATA), CAddChatWnd::MemberDataItemComareFunc, this);	

	vector<wstring> vecUsers;
	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ORGCHARTDLG);
	for (size_t i=0; i<memberVector.size(); ++i)
	{
		AddChatListItemInfo item;
		item.id = memberVector[i].neMemberData.strUserId.c_str();
		item.folder = false;
		//item.empty = false;
		item.nick_name = memberVector[i].neMemberData.strName.c_str();
		item.position = memberVector[i].neMemberData.strJobPos.c_str();
		item.organization = memberVector[i].neMemberData.strDept.c_str();

		CString strImage = _T("");
		GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(item.id);
		bool mobile = ( eUserStatus & ustMOBILE );
		if ((eUserStatus==ustONLINE) || mobile)
		{
			strImage = GET_APP()->GetProfileImagePath(item.id.GetData());
		}
		else
		{
			strImage = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(eUserStatus,FALSE,!memberVector[i].neMemberData.strWorkStatus.empty());
		}
		
		if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(memberVector[i].neMemberData.strUserId.c_str()))
		{
			eUserStatus = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();
			item.logo = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(eUserStatus);
			GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->UpdateMemberStatus(memberVector[i].neMemberData.strUserId.c_str(), eUserStatus);
		}
		else
		{
			item.logo = strImage;
		}
		AddNode(item, NULL, &memberVector[i].neMemberData, eUserStatus);
		vecUsers.push_back(memberVector[i].neMemberData.strUserId);
	}
	ResizeList();
	CLabelUI* pDefaultShow = (CLabelUI*)m_PaintManager.FindControl(kNosearchResult);
	if(NULL != pDefaultShow && memberVector.size() == 0)
	{
		pDefaultShow->SetText(LoadStringFromResource(IDS_STRING_NOSEARCH_RESULT));
		pDefaultShow->SetVisible(true);
	}

	g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_ORGCHARTDLG);
}


void CAddChatWnd::UpdateCheckStatus( LPCWSTR strUserId , bool bEnable)
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		int nCount = pList->GetCount();
		for (int i=0; i<nCount; ++i)
		{
			CControlUI* pItem = pList->GetItemAt(i);
			CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
			CAddUserListData *pMembereData = (CAddUserListData*)item_check->GetTag();
			if (pMembereData!=NULL && pMembereData->GetUserID() == strUserId)
			{
				if (m_nParentType == ADD_USER_FROM_SMS)
				{
					item_check->SetEnabled(bEnable);
					break;
				}
			}
		}
	}
}

void CAddChatWnd::UpdateMemberStatus(LPCWSTR strUserId)
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		int nCount = pList->GetCount();
		for (int i=0; i<nCount; ++i)
		{
			CControlUI* pItem = pList->GetItemAt(i);
			CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
			CAddUserListData *pMembereData = (CAddUserListData*)item_check->GetTag();
			if (pMembereData!=NULL && pMembereData->GetUserID() == strUserId)
			{
				CButtonUI* logo_button = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kLogoButtonControlName));
				CLabelUI* item_name = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, _T("item_name")));
				if (logo_button != NULL && item_name != NULL)
				{
					CString strImage = _T("");
					const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(strUserId);
					GTUserStatusType eUserStatus = ustOFFLINE;
                    if (pUser)
					{
						eUserStatus = pUser->GetStatus();		
					}
					else
					{
						eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(strUserId);
					}				
					//bool mobile = ( eUserStatus & ustMOBILE );
					/*if ((eUserStatus==ustONLINE) || mobile)
					{
						strImage = GET_APP()->GetProfileImagePath(strUserId);
					}
					else
					{
						strImage = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(eUserStatus);
					}*/

					strImage = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(eUserStatus,FALSE,!pMembereData->GetMemberData().strWorkStatus.empty());
                    logo_button->SetBkImage(strImage);
				/*	logo_button->SetNormalImage(strImage);
					logo_button->SetHotImage(strImage);*/
					
					CString strBuf = _T("");
					strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pMembereData->GetMemberData().strName.c_str(), GetPresenceTip(eUserStatus), pMembereData->GetMemberData().strEmail.c_str());
					item_name->SetToolTip(strBuf);
					//logo_button->SetToolTip(strBuf);
					if (ustOFFLINE == eUserStatus && GET_CONFIG()->EnableFunction(_T("UI_01")) && !pMembereData->GetMemberData().strWorkStatus.empty())
					{
						CString strToolTip = pMembereData->GetMemberData().strWorkStatus.c_str();
						strToolTip.Replace(_T(":"),_T("\n"));
						logo_button->SetToolTip(strToolTip);
					}
					else
					{
						logo_button->SetToolTip(strBuf);
					}
					
					if (m_nParentType == ADD_USER_FROM_CHAT)
					{
						if (eUserStatus != ustOFFLINE)
						{
							int pos = m_strInChatRoom.Find(strUserId);
							if (pos == -1)
							{
								item_check->SetEnabled(true);
							}
						}
						else
						{
							item_check->SetEnabled(false);
						}
					}
				}
			}
		}
	}
}

void CAddChatWnd::ChangeMyStatus(GTUserStatusType eMyStatus)
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->UpdateMemberStatus(myUserData.strUserID, eMyStatus);
	UpdateMemberStatus(myUserData.strUserID);
}

Node* CAddChatWnd::AddNode(const AddChatListItemInfo& item, Node* parent, const NE_MEMBER_DATA* pMembereData, GTUserStatusType status)
{
	if (!parent)
		parent = root_node_;

	TCHAR szBuf[MAX_PATH] = {0};

    CListContainerElementUI* pListElement = NULL;
    if( !m_dlgBuilder.GetMarkup()->IsValid() ) {
        pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create(_T("AddChatListItem.xml"), (UINT)0, NULL, &m_PaintManager));
    }
    else {
        pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create((UINT)0, &m_PaintManager));
    }
    if (pListElement == NULL)
        return NULL;

	Node* node = new Node;

	node->data().level_ = parent->data().level_ + 1;
	if (item.folder)
	{
		node->data().has_child_ = !item.empty;
	}
	else
	{
		node->data().has_child_ = false;
	}

	node->data().folder_ = item.folder;

	node->data().child_visible_ = (node->data().level_ == 0);
	node->data().child_visible_ = false;

	node->data().text_ = item.nick_name;
	node->data().value = item.id;
	node->data().list_elment_ = pListElement;

	if (!parent->data().child_visible_)
		pListElement->SetVisible(false);

	if (parent != root_node_ && !parent->data().list_elment_->IsVisible())
		pListElement->SetVisible(false);

	CDuiRect rcPadding = text_padding_;
	for (int i = 0; i < node->data().level_; ++i)
	{
		rcPadding.left += 23;
	}
	if (!node->folder())
	{
		rcPadding.left += 2;
	}
	pListElement->SetPadding(rcPadding);

	CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kAddChatItemCheck));
	SetCheckItemEnable(item_check, item.id.GetData(), pMembereData, status);

	CButtonUI* log_button = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kLogoButtonControlName));
	if (log_button != NULL)
	{
		if (!item.folder && !item.logo.IsEmpty())
		{
			CButtonUI* log_hot_button = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, _T("logo_hot")));
			if (log_hot_button != NULL)
			{
				//log_hot_button->SetNormalImage(_T("img_main_organization_profile_s_bar.png"));
				log_hot_button->SetVisible(false);
			}
			_stprintf_s(szBuf, MAX_PATH - 1, _T("%s"), item.logo);
			/*log_button->SetNormalImage(szBuf);
			log_button->SetHotImage(szBuf);*/
			log_button->SetBkImage(szBuf);
			//log_button->SetFixedHeight(20);
			//log_button->SetFixedWidth(20);
			CString strBuf = _T("");
			strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pMembereData->strName.c_str(), GetPresenceTip(status), pMembereData->strEmail.c_str());
			
			if (ustOFFLINE == status && GET_CONFIG()->EnableFunction(_T("UI_01")) && !pMembereData->strWorkStatus.empty())
			{
				CString strToolTip = pMembereData->strWorkStatus.c_str();
				strToolTip.Replace(_T(":"),_T("\n"));
				log_button->SetToolTip(strToolTip);
			}
			else
			{
				log_button->SetToolTip(strBuf);
			}
		}
		else
		{
			CContainerUI* logo_container = static_cast<CContainerUI*>(m_PaintManager.FindSubControlByName(pListElement, kLogoContainerControlName));
			if (logo_container != NULL)
				logo_container->SetVisible(false);
		}
        log_button->SetTag((UINT_PTR)pListElement);
        log_button->OnEvent += MakeDelegate(&OnLogoButtonEvent);
	}

	CDuiString html_text;

	if (item.folder)
	{
		html_text += node->data().text_;
	}
	else
	{
		CString strBuf = _T("");
		CString strFullName = item.nick_name;
		CString strSearch = m_strSearchWord;
		strFullName.MakeUpper();
		strSearch.MakeUpper();
		html_text = strFullName;
		int nFindIndex = strFullName.Find(strSearch);
		if (nFindIndex >= 0)
		{
			CString strLeft = strFullName.Left(nFindIndex);
			CString strRight = strFullName.Right(strFullName.GetLength()-strFullName.Find(strSearch)-strSearch.GetLength());
			strBuf.Format(_T("<c #000000>%s</c><c #187AFF>%s</c><c #000000>%s</c>"), strLeft, strSearch, strRight);
			html_text = strBuf;
		}
	}

	CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, _T("item_name")));
	if (nick_name != NULL)
	{
		if (item.folder)
		{
			nick_name->SetTextColor(RGB(0x66, 0x66, 0x66));
		}
		nick_name->SetShowHtml(true);
		nick_name->SetText(html_text);
		CString strBuf = _T("");
		strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pMembereData->strName.c_str(), GetPresenceTip(status), pMembereData->strEmail.c_str());
		nick_name->SetToolTip(strBuf);
	}

	CLabelUI* pPosition = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, kAddChatItemPosition));
	if (pPosition != NULL)
	{
		pPosition->SetText(item.position);
		pPosition->SetToolTip(item.position);
	}

	CLabelUI* pOrganization = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, kAddChatItemOrganization));
	if (pOrganization != NULL)
	{
		pOrganization->SetText(item.organization);
		pOrganization->SetToolTip(item.organization);
	}
	
	if (item.folder)
	{
		pListElement->SetFixedHeight(kOrganizationItemFileHeight);
	}
	else
	{
		pListElement->SetFixedHeight(kOrganizationItemUserHeight);
	}
	
	pListElement->SetTag((UINT_PTR)node);
	int index = 0;
	if (parent->has_children())
	{
		Node* prev = parent->get_last_child();
		index = prev->data().list_elment_->GetIndex() + 1;
	}
	else 
	{
		if (parent == root_node_)
			index = 0;
		else
			index = parent->data().list_elment_->GetIndex() + 1;
	}
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList!=NULL && !pList->AddAt(pListElement, index))
	{
		delete pListElement;
		delete node;
		node = NULL;
	}
	if (node != NULL)
	{
		parent->add_child(node);
	}
	
	return node;
}

void CAddChatWnd::SetCheckItemEnable(CButtonUI* item_check, CString strUserID, const NE_MEMBER_DATA* pMembereData, GTUserStatusType status)
{
	if (item_check != NULL)
	{
		CAddUserListData *pListData = new CAddUserListData(*pMembereData);
		m_vecMemberData.push_back(pListData);
		item_check->SetTag((UINT_PTR)pListData);
		if (m_nParentType == ADD_USER_FROM_CHAT)
		{
			int pos = m_strInChatRoom.Find(strUserID);
			if (pos == -1)
			{
				if (status == ustOFFLINE)
				{
					item_check->SetEnabled(false);
				}
				else
				{
					item_check->SetEnabled(true);
				}
			}
			else
			{
				item_check->SetEnabled(false);
			}
		}
		else if (m_nParentType == ADD_USER_FROM_NOTE)
		{
			CMemoSendDlg *pMemoSendDlg = (CMemoSendDlg*)m_pCWndParent;
			if (pMemoSendDlg != NULL)
			{
				vector<ReceiverInfo> *pVecReceiverInfo = pMemoSendDlg->GetReceiverInfo();
				if (pVecReceiverInfo != NULL)
				{
					vector<ReceiverInfo>::iterator it = pVecReceiverInfo->begin();
					for (; it!=pVecReceiverInfo->end(); ++it)
					{
						if (strUserID == (*it).strID.c_str())
						{
							item_check->SetEnabled(false);
							break;
						}
					}
				}
			}
		}

		else if(m_nParentType == ADD_USER_FROM_SMS)
		{
			CSMSSendWnd *pSMSSendWnd = (CSMSSendWnd*)m_pDUIParent;
			if(pSMSSendWnd == NULL) return;

			std::vector<CSMSModel::SMSReceiverInfo> *pVecReceivers = pSMSSendWnd->GetSMSReceivers();
			if(pVecReceivers != NULL)
			{
				for(int i = 0; i < (int)pVecReceivers->size(); i++)
				{
					CSMSModel::SMSReceiverInfo info = (*pVecReceivers)[i];
					if (strUserID == info.strID)
					{
						item_check->SetEnabled(false);
						break;
					}
				}
			}
			
		}
	}
}

void CAddChatWnd::SetRequestID(LPCTSTR strID)
{
	m_strID = strID;
	m_trid = 0;
	g_pMessengerActor->GetWASActor()->RegisterObserver(this);
	g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(m_strID, GetLanguageStringUnicode(), reitSingleTrans, &m_trid);

	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	m_strMyID = myUserData.strUserID;
}

LPCTSTR CAddChatWnd::GetWindowClassName() const
{
	return _T("AddChatWindow");
}

void CAddChatWnd::OnFinalMessage(HWND hWnd)
{
	RemoveAllMenberList();
	WindowImplBase::OnFinalMessage(hWnd);
	if (m_pParentChatDlg != NULL && ::IsWindow(m_pParentChatDlg->GetHWND()))
	{
		::PostMessage(m_pParentChatDlg->GetHWND(), MSG_CLOSE_INVITE_WINDOWN, 0, 0);
	}
}

bool CAddChatWnd::SendUserListToParent()
{
	std::vector<NE_MEMBER_DATA> selectedUserVector;
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		int nCount = pList->GetCount();
		for (int i=0; i<nCount; ++i)
		{
			CControlUI* pItem = pList->GetItemAt(i);
			CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
			if (item_check != NULL)
			{
				CString strImage = item_check->GetBkImage();
				if (strImage == CHECK_ON && item_check->IsEnabled())
				{
					CAddUserListData *pMembereData = (CAddUserListData*)item_check->GetTag();
					selectedUserVector.push_back(pMembereData->GetMemberData());
				}
			}

		}
		/*
		if(NULL != m_pParentChatDlg)
		{
			m_pParentChatDlg->AddUser(selectedUserVector);
		}
		*/
		////////////////////////////////
		if (selectedUserVector.size() > 0)
		{
			if (m_nParentType == ADD_USER_FROM_CHAT)
			{
				//CChatDlg* pParent = (CChatDlg*)m_pParent;
				//pParent->AddUser(selectedUserVector);
				if(NULL != m_pParentChatDlg)
				{
					m_pParentChatDlg->AddUser(selectedUserVector);
				}

			}
			else if (m_nParentType == ADD_USER_FROM_NOTE)
			{
				CMemoSendDlg* pParent = (CMemoSendDlg*)m_pCWndParent;
				pParent->AddUser(selectedUserVector);
			}
			else if (m_nParentType == ADD_USER_FROM_SMS)
			{				
				m_pParentSmsSendWnd->AddUser(selectedUserVector);
			}
			else if (m_nParentType == ADD_USER_FROM_DIALPAD)
			{
				if( selectedUserVector.size() > 1 )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING586));	
					return false;
				}

				if( selectedUserVector.begin()->strUserId == g_pMessengerActor->GetUserID() )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING588));	
					return false;
				}

				if( selectedUserVector.begin()->strExtesion.empty() )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING589));
					return false;
				}

				// ȣ ȯ     .
				CDialPadDlg* pParent = (CDialPadDlg*)m_pCWndParent;
				pParent->SetTransferUser(selectedUserVector);

				Close();
			}
			else if (m_nParentType == ADD_USER_FROM_TOPMENU_CALLTRANSFER)
			{
				if( selectedUserVector.size() > 1 )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd),  LoadStringFromResource(IDS_STRING586));	
					return false;
				}
				else if( selectedUserVector.begin()->strUserId == g_pMessengerActor->GetUserID() )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING588));
					return false;
				}
				else if( selectedUserVector.begin()->strExtesion.empty() )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING589));	
					return false;
				}
				else
				{
					g_pMessengerActor->RequestCallTransfer( g_pMessengerActor->GetUserID(), selectedUserVector.begin()->strUserId.c_str() );
				}

				Close();
			}
			else if (m_nParentType == ADD_USER_FROM_CONFERENCECALL)
			{
				if( selectedUserVector.size() > 1 )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd),  LoadStringFromResource(IDS_STRING586));	
					return false;
				}
				else if( selectedUserVector.begin()->strUserId == g_pMessengerActor->GetUserID() )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING588));	
					return false;
				}
				else if( selectedUserVector.begin()->strExtesion.empty() )
				{
					NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING589));	
					return false;
				}
				else
				{
					g_pMessengerActor->RequestConferenceCall( g_pMessengerActor->GetUserID(), selectedUserVector.begin()->strExtesion.c_str() );
				}

				Close();
			}
		}
		
	}

	return TRUE;
}

int CAddChatWnd::GetSelectCount()
{
	int nSelectCount = 0;
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		int nCount = pList->GetCount();
		for (int i=0; i<nCount; ++i)
		{
			CControlUI* pItem = pList->GetItemAt(i);
			CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
			if (item_check != NULL)
			{
				CString strImage = item_check->GetBkImage();
				if (strImage == CHECK_ON  && item_check->IsEnabled())
				{
					nSelectCount++;
				}
			}
		}
	}
	return nSelectCount;
}

void CAddChatWnd::_OnNotifySetFocus(TNotifyUI& msg)
{
    CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
    if (searchEdit != NULL)
    {
        searchEdit->SetFocus();
    }
}

void CAddChatWnd::_OnNotifyKillFocus(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kSearchEdit) == 0)
    {
        msg.pSender->SetVisible(false);
        CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
        if (searchLabel != NULL)
        {
            searchLabel->SetVisible(true);
            if (msg.pSender->GetText().GetLength() == 0)
            {
                searchLabel->SetText(LoadStringFromResource(IDS_STRING245));
            }
            else
            {
                m_strSearchWord = msg.pSender->GetText();
                searchLabel->SetText(m_strSearchWord);
            }
        }
    }
}

void CAddChatWnd::_OnCtrlCloseBtnClick(TNotifyUI& msg)
{
    RemoveAllMenberList();
    Close();
}

void CAddChatWnd::_OnCtrlSearchLabelClick(TNotifyUI& msg)
{
    msg.pSender->SetVisible(false);
    CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
    if (searchEdit != NULL)
    {
        m_strSearchWord = _T("");//msg.pSender->GetText();
        searchEdit->SetText(m_strSearchWord);
        searchEdit->SetVisible(true);
        searchEdit->SetFocus();
    }
}

void CAddChatWnd::_OnCtrlSearchBtnClick(TNotifyUI& msg)
{
    OnSearchUser();
}

void CAddChatWnd::_OnCtrlSearchCancelClick(TNotifyUI& msg)
{
    CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
    if (searchLabel != NULL)
    {
        m_strSearchWord = _T("");
        searchLabel->SetText(LoadStringFromResource(IDS_STRING245));
        msg.pSender->SetVisible(false);
        RemoveAllMenberList();
        CLabelUI* pDefaultShow = (CLabelUI*)m_PaintManager.FindControl(kNosearchResult);
        if(NULL != pDefaultShow)
        {
            pDefaultShow->SetVisible(false);
        }
        InitList();
    }
}
void CAddChatWnd::_OnCtrlAddChatItemCheckClick(TNotifyUI& msg)
{
    CString strImage = msg.pSender->GetBkImage();
    if (strImage == CHECK_OFF)
    {
        msg.pSender->SetBkImage(CHECK_ON);
    }
    else
    {
        msg.pSender->SetBkImage(CHECK_OFF);
    }
    if(GetSelectCount() == 0)
    {
        CButtonUI* pBtnOK = static_cast<CButtonUI*>(m_PaintManager.FindControl(kInviteOK));
        if (pBtnOK != NULL)
        {
            pBtnOK->SetEnabled(false);
        }
    }
    else
    {
        CButtonUI* pBtnOK = static_cast<CButtonUI*>(m_PaintManager.FindControl(kInviteOK));
        if (pBtnOK != NULL)
        {
            pBtnOK->SetEnabled(true);
        }
    }
}

void CAddChatWnd::_OnCtrlInviteOKClick(TNotifyUI& msg)
{
    SendUserListToParent();
    Close();
}
void CAddChatWnd::_OnCtrlInviteCancelClick(TNotifyUI& msg)
{
    RemoveAllMenberList();
    Close();
}

void CAddChatWnd::_OnNotifyHeaderClick(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kAddChatCheck) == 0)
    {
        CListHeaderItemUI *pHeaderItem = (CListHeaderItemUI *)msg.pSender;
        CString strImage = pHeaderItem->GetNormalImage();
        if (strImage == _T("file='btn_chat_talk_checkboc_off.png' dest='8,10,21,23'"))
        {
            CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
            if (pList != NULL)
            {
                int nCount = pList->GetCount();
                for (int i=0; i<nCount; ++i)
                {
                    CControlUI* pItem = pList->GetItemAt(i);
                    CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
                    if (item_check != NULL && item_check->IsEnabled())
                    {
                        item_check->SetBkImage(CHECK_ON);
                    }

                }
                pHeaderItem->SetNormalImage(_T("file='btn_chat_talk_checkboc_on.png' dest='8,10,21,23'"));
            }
        }
        else
        {
            CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
            if (pList != NULL)
            {
                int nCount = pList->GetCount();
                for (int i=0; i<nCount; ++i)
                {
                    CControlUI* pItem = pList->GetItemAt(i);
                    CButtonUI* item_check = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemCheck));
                    if (item_check != NULL && item_check->IsEnabled())
                    {
                        item_check->SetBkImage(CHECK_OFF);
                    }

                }
                pHeaderItem->SetNormalImage(_T("file='btn_chat_talk_checkboc_off.png' dest='8,10,21,23'"));
            }
        }
        if(GetSelectCount() == 0)
        {
            CButtonUI* pBtnOK = static_cast<CButtonUI*>(m_PaintManager.FindControl(kInviteOK));
            if (pBtnOK != NULL)
            {
                pBtnOK->SetEnabled(false);
            }
        }
        else
        {
            CButtonUI* pBtnOK = static_cast<CButtonUI*>(m_PaintManager.FindControl(kInviteOK));
            if (pBtnOK != NULL)
            {
                pBtnOK->SetEnabled(true);
            }
        }
    }
}

void CAddChatWnd::_OnNotifyHeaderDrag(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kAddChatName) == 0)
    {
        CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
        if (pList != NULL)
        {
            int nHeaderWidth = msg.pSender->GetFixedWidth();
            CListHeaderItemUI* pListItemPos = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatPosition));
            int nHeaderWidthPos = pListItemPos->GetFixedWidth();
            int nCount = pList->GetCount();
            int nNamePosOrgWidth = 300;
            if (nCount > 9)		// show scroll bar when nCount > 9 
            {
                nNamePosOrgWidth = 282;
            }
            for (int i=0; i<nCount; ++i)
            {
                CControlUI* pItem = pList->GetItemAt(i);
                CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kLogoContainerControlName));
                CLabelUI* pOrganization = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemOrganization));
                if (nick_name != NULL)
                {
                    nick_name->SetFixedWidth(nHeaderWidth+16);
                }
                if (pOrganization != NULL)
                {
                    pOrganization->SetFixedWidth(nNamePosOrgWidth - (nHeaderWidth+16+nHeaderWidthPos));
                }
            }
        }
    }
    else if (_tcsicmp(msg.pSender->GetName(), kAddChatPosition) == 0)
    {
        CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
        if (pList != NULL)
        {
            int nHeaderWidth = msg.pSender->GetFixedWidth();
            CListHeaderItemUI* pListItemName = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatName));
            int nHeaderWidthName = pListItemName->GetFixedWidth();
            int nCount = pList->GetCount();
            int nNamePosOrgWidth = 300;
            if (nCount > 9)		// show scroll bar when nCount > 9 
            {
                nNamePosOrgWidth = 282;
            }
            for (int i=0; i<nCount; ++i)
            {
                CControlUI* pItem = pList->GetItemAt(i);
                CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemPosition));
                if (nick_name != NULL)
                {
                    nick_name->SetFixedWidth(nHeaderWidth-12);
                }
                CLabelUI* pOrganization = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemOrganization));
                if (pOrganization != NULL)
                {
                    pOrganization->SetFixedWidth(nNamePosOrgWidth - (nHeaderWidth+4+nHeaderWidthName));
                }
            }
        }
    }
}

void CAddChatWnd::_OnNotifyReturn(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kSearchEdit) == 0)
    {
		if (msg.wParam == WM_KEYDOWN)
		{
			OnSearchUser();
		}
    }
}

void CAddChatWnd::_OnNotifyEscape(TNotifyUI& msg)
{
    if (msg.wParam == WM_KEYDOWN)
    {
        if (_tcsicmp(msg.pSender->GetName(), kSearchEdit) == 0)
        {
            CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
            if (searchEdit != NULL)
            {
                if (searchEdit->GetText().GetLength() > 1)
                {
                    m_strSearchWord = _T("");
                    searchEdit->SetText(m_strSearchWord);
                    m_PaintManager.SetFocus(NULL);
                }
                else
                {
                    RemoveAllMenberList();
                    Close();
                }
            }
        }
    }
}

void CAddChatWnd::ResizeList()
{
	CListHeaderItemUI* pListItemName = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatName));
	int nHeaderWidthName = pListItemName->GetFixedWidth();
	pListItemName->SetFixedWidth(140);
	CListHeaderItemUI* pListItemPos = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatPosition));
	int nHeaderWidthPos = pListItemPos->GetFixedWidth();
	pListItemPos->SetFixedWidth(60);
	CListHeaderItemUI* pListItemOrg = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatOrganization));
	int nHeaderWidthOrg = pListItemOrg->GetFixedWidth();
	pListItemOrg->SetFixedWidth(100);

	/*
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kAddChatList));
	if (pList != NULL)
	{
		int nCount = pList->GetCount();
		for (int i=0; i<nCount; ++i)
		{
			CControlUI* pItem = pList->GetItemAt(i);
			CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemPosition));
			CLabelUI* pPosition = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemPosition));
			CLabelUI* pOrganization = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pItem, kAddChatItemOrganization));
			nick_name->SetFixedWidth(nHeaderWidthName);
			pPosition->SetFixedWidth(nHeaderWidthPos);
			pOrganization->SetFixedWidth(nHeaderWidthOrg);
		}
	}
	*/
}

void CAddChatWnd::OnSearchUser()
{
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
	if (searchEdit != NULL)
	{
		CLabelUI* pDefaultShow = (CLabelUI*)m_PaintManager.FindControl(kNosearchResult);
		if(NULL != pDefaultShow)
		{
			pDefaultShow->SetVisible(false);
		}
		m_strSearchWord = searchEdit->GetText();
		CString strSearch = m_strSearchWord.Trim(_T("% "));;
		if (strSearch.GetLength() > 1)
		{
			CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchCancel));
			if (search_cancel != NULL)
			{
				search_cancel->SetVisible(true);
				g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ADDUSERDLG);
				GET_MESSENGER_DLG()->GetWorkGroupController()->RequestAddUserSearchList(m_strSearchWord);
				CListHeaderItemUI* pHeaderItem = static_cast<CListHeaderItemUI*>(m_PaintManager.FindControl(kAddChatCheck));
				if (pHeaderItem != NULL)
				{
					pHeaderItem->SetNormalImage(_T("file='btn_chat_talk_checkboc_off.png' dest='8,10,21,23'"));
				}
			}
		}
		else
		{
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING169));
			if (searchEdit != NULL)
			{
				searchEdit->SetVisible(true);
				searchEdit->SetFocus();
			}
		}
	}	
}

bool CAddChatWnd::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{
	if (m_trid != trid)
		return true;

	if (eErrorCode != wasError_None)
		return false;

	if (list.nSize <= 0)
		return false;

	::ShowWindow(m_hWnd, SW_SHOW);
	

	const NE_MEMBER_DATA &sMemberInfo = list.pList[0];
	m_userData = sMemberInfo;

	OnUserImageUpdated(sMemberInfo.strUserId.c_str());
	CTextUI* pUserName = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("user_name")));
	if(pUserName != NULL)
	{
		pUserName->SetText(sMemberInfo.strName.c_str());
	}
	CLabelUI* pMail = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("edit_mail")));
	if (pMail != NULL)
	{
		pMail->SetText(sMemberInfo.strEmail.c_str());
	}
	CLabelUI* pExt = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("edit_ext")));
	if (pExt != NULL)
	{
		pExt->SetText(sMemberInfo.strExtesion.c_str());
	}
	CLabelUI* pMobile = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("edit_mobile")));
	if (pMobile != NULL)
	{
		pMobile->SetText(sMemberInfo.strCellPhone.c_str());
	}
	CLabelUI* pOrg = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("edit_org")));
	if (pOrg != NULL)
	{
		pOrg->SetText(sMemberInfo.strDept.c_str());
	}
	CLabelUI* pCity = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("edit_city")));
	if (pCity != NULL)
	{
		pCity->SetText(sMemberInfo.strWorkPlace.c_str());
	}
	CLabelUI* pDepartment = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("department")));
	if (pDepartment != NULL)
	{
		pDepartment->SetText(sMemberInfo.strDept.c_str());
	}

	CLabelUI* pFavorite = static_cast<CLabelUI*>(m_PaintManager.FindControl(kProfileFavorite));
	if (pFavorite != NULL)
	{
		vector<CString> vecBookmark = GET_MESSENGER_DLG()->GetMainFrame()->GetBookmarkVector();
		vector<CString>::iterator it = find(vecBookmark.begin(), vecBookmark.end(), sMemberInfo.strUserId.c_str());
		if (it != vecBookmark.end())
		{
			pFavorite->SetBkImage(_T("btn_main_bookmark_icon_sel.png"));
		}
		else
		{
			pFavorite->SetBkImage(_T("btn_main_bookmark_icon_nor.png"));
		}
	}

	if (sMemberInfo.strPhotoURL.empty() != true && (m_strID == m_strMyID || GET_CONFIG()->EnableFunction(_T("UI_02")) == TRUE))
	{
		//CUserImageActor::Instance()->RequestUserImage(sMemberInfo.strUserId.c_str(),
		//	sMemberInfo.strPhotoURL.c_str());
	}

	return true;
}

LRESULT CAddChatWnd::_OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if ((TCHAR)wParam == VK_ESCAPE)
    {
        RemoveAllMenberList();
        Close();
        return 0;
    }
    if(GetKeyState(VK_CONTROL) < 0)
    {
        if(wParam == 'F' || wParam == 'f')
        {
            CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
            CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
            if(searchLabel != NULL)
            {
                searchLabel->SetVisible(false);
                searchEdit->SetVisible(true);
                searchEdit->SetFocus();
                return 0;
            }
        }
    }

    bHandled = FALSE;
    return 0;
}

void CAddChatWnd::OnUserImageUpdated(CString strUserId)
{
	UpdateProfileImage(strUserId);
}

void CAddChatWnd::UpdateProfileImage(CString strUserId)
{
	if(strUserId != m_strID)
	{
		return;
	}

	CLabelUI* pProfilePic = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("profile_pic")));
	if (pProfilePic != NULL)
	{
        CString strFileName = GET_APP()->GetProfileImagePath(m_strID);

        pProfilePic->SetBkImage(strFileName);
        pProfilePic->Invalidate();
	}
}


void CAddChatWnd::OnPrepare(TNotifyUI& msg)
{
	CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
	if (searchLabel != NULL)
	{
		searchLabel->SetVisible(false);
		searchLabel->SetText(LoadStringFromResource(IDS_STRING245));
	}

	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSearchEdit));
	if (searchEdit != NULL)
	{
		searchEdit->SetVisible(true);
	}
}

CDuiString CAddChatWnd::GetSkinFile()
{
	return _T("AddChatWnd.xml");
}

CDuiString CAddChatWnd::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}

LRESULT CAddChatWnd::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}

void CAddChatWnd::OnUserImageActor_OnResponseUserImageInfo(CString strUserId)
{
	PostMessage(WM_USERIMAGE_UPDATED, (WPARAM)(new CString(strUserId)), 0);
}

LRESULT CAddChatWnd::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	int ret = __super::OnNcHitTest(uMsg, wParam, lParam, bHandled);
	if (ret != HTCAPTION)
	{
		ret = HTCLIENT;
	}
	return ret;
}

